theory Test
imports Testing
begin


ML
{*
open TestGen;

fun max_depth (Free h) = (0,[h])
   |max_depth (Const h)= (0,[])
   |max_depth (Abs(s,tt,t)) = max_depth t
   |max_depth (s $ t) = let val (k,S) = max_depth (s)
                            val (k',S') = max_depth (t)
                        in  if k > k'+1 then (k,S)
                            else if k = k'+1 then (k, S @ S')
                                 else (k'+1, S')
                        end
   |max_depth (_) = (0,[]);


fun get_exhaust_of type_name thy =
    #exhaustion(the(Symtab.lookup(DatatypePackage.get_datatypes thy) type_name));
fun get_nchotomy_of type_name thy =
    #nchotomy(the(Symtab.lookup(DatatypePackage.get_datatypes thy) type_name));


fun prems_hyp_subst_tac thy name H1 =  
    let fun stripC (Const("==>",t) $ H1 $ (Const("==>",_)$ _ $ H2))=
            Const("==>",t) $ H1 $ H2
		 |stripC (Const("all",t) $ (Abs(s,t',H))) = 
            Const("all",t) $ (Abs(s,t', stripC H)); 
      fun stripD name (Const("all",t) $ (Abs(s,t',H))) = 
          if s = name then incr_bv (~1, 0,stripC H)
          else Const("all",t) $ (Abs(s,t', stripD name H)); 
    val H2     = stripD name H1;
  val cgoal1 = cterm_of ( thy) (Logic.mk_implies(H1,H2));
val cgoal2 = cterm_of ( thy) (Logic.mk_implies(H2,H1));
val pp1 = (trivial cgoal1) |$> (rtac (assume (cterm_of thy H1)) 1) |$> (atac 1) |$> (rtac refl 1);
val pp2 = (trivial cgoal2) |$> (rtac (assume (cterm_of thy H2)) 1) |$> (atac 1);
    in  equal_intr pp1 pp2 end;

val changed = ref false;

*}
ML
{*


fun refine_data_separation_lemma thy clasimp bal prem_no cands thm =
(* - bal controls of the refinement is in balancing mode
     (only parameters whose occurrence in the term is
      has strictly less than maximum height)
     or not. 
   - prem_no indicates the number of the premise
   - cands is the global list of candidates.
     In balancing mode, parameters in maximal depth
     position were eliminated.
 *)
let (* val thy    = theory_of_thm thm *)
    val prem   = List.nth(prems_of thm, prem_no - 1)
    val params = Logic.strip_params(prem)

    val cands' = if bal then 
                    let val term   = HOLogic.dest_Trueprop(hd
                                            (Logic.strip_assums_hyp prem))
                        val (k,mp) = max_depth(Term.subst_bounds
                                            ((rev(map Free params)),term))
                    in filter(fn p => forall(fn p'=> not(p=p')) (mp)) cands end
                 else cands;

    val var_no = find_index (fn(s,t)=> exists(fn (name,ty)=> 
                                             s = name andalso t = ty) cands')
                             params
    val (name,ty)  = if var_no > ~1 then List.nth(params,var_no)
                     else raise (ERROR("no param found"))
    val Type(tn,_) = ty;
    val m          = get_exhaust_of tn thy;
    val n          = m RSN (prem_no,thm);

    (* generates a projection function % x1 ... xn. xk of the form
       "%x x y . x" in order to instantiate the freshly generated
       meta-variable y1 in the RSN step above. y1 will occur
       lifted over the parameters param and can therefore be grounded
       by this projection *) 
    val proj  = concat(["%"] @ (replicate  (var_no+1) "x ") @ 
                       (replicate  (length(params) - var_no - 1) "y ") @ 
                       [". x"])
    val p     = read_instantiate (Variable.thm_context n) [(("y",1),proj)] n; (* always y1 ? *)

    (* Now, why is the rest so complicated ?
       val p' = rule_by_tactic (ALLGOALS hyp_subst_tac) p; 
       destroys everything, on the other hand, 
       rule_by_tactic (prune_params_tac) p'; has no effect at all. 
       Therefore, the following rewrite  plus cleanup is necessary *)
    val p'    = rule_by_tactic (ALLGOALS (asm_full_simp_tac
                                          (snd clasimp))) p;
 (*   val simps = Library.mapfilter  *)
 (*               (try(prems_hyp_subst_tac (theory_of_thm p') name))  *)
 (*               (prems_of (fst(freeze_thaw(p')))); *)
    val simps = List.mapPartial 
                (try(prems_hyp_subst_tac thy name)) 
                (prems_of (fst(freeze_thaw(p'))));
  
    val ()    = (changed:=true)
in  rule_by_tactic (ALLGOALS (asm_full_simp_tac 
                                  (HOL_ss addsimps simps))) p'
end;



*}

ML{*
val ctx = @{context};
val thy = @{theory};
val clasimp = @{clasimpset};
val thm = get_exhaust_of "List.list" thy 
val cands         = distinct (op=) (filter (fn(_,ty)=> isDataType thy ty) 
                                           (Library.flat(map Logic.strip_params 
	                           (prems_of thm))));

TestGen.refine_data_separation_lemma  thy clasimp false 2 cands thm;
*}

ML{*Context.theory_of_proof @{context};
res_inst_tac*}